#!/bin/bash
# DO NOT EDIT THIS FILE

ocamlbuild -use-ocamlfind enigma.byte
if [[ $? -ne 0 ]]; then
  cat <<EOF
===========================================================
WARNING

Your code currently does not compile.  You will receive
little to no credit for submitting this code. Check the
error messages above carefully to determine what is wrong.
See a consultant for help if you cannot determine what is
wrong.
===========================================================
EOF
  exit 1
fi

cat >checktypes.ml <<EOF
(* DO NOT EDIT THIS FILE *)
let check_index : char -> int = Enigma.index
let check_map_r_to_l : string -> char -> int -> int = Enigma.map_r_to_l
let check_map_l_to_r : string -> char -> int -> int = Enigma.map_l_to_r
let check_map_refl : string -> int -> int = Enigma.map_refl
let check_map_plug : (char * char) list -> char -> char = Enigma.map_plug
let check_rotor : Enigma.rotor = {Enigma.wiring=""; turnover='A'}
let check_oriented_rotor : Enigma.oriented_rotor = {Enigma.rotor=check_rotor; top_letter='A'}
let check_config : Enigma.config = {Enigma.refl=""; rotors=[check_oriented_rotor]; plugboard=[('A','A')]}
let check_cipher_char : Enigma.config -> char -> char = Enigma.cipher_char
let check_step : Enigma.config -> Enigma.config = Enigma.step
let check_cipher : Enigma.config -> string -> string = Enigma.cipher
EOF

if ocamlbuild -use-ocamlfind checktypes.byte ; then
  cat <<EOF
===========================================================
Your function names and types look good to me.
Congratulations!
===========================================================
EOF
else
  cat <<EOF
===========================================================
WARNING

Your function names and types look broken to me.  The code
that you submit might not compile on the grader's machine,
leading to heavy penalties.  Please fix your names and
types.  Check the error messages above carefully to
determine what is wrong.  See a consultant for help if you
cannot determine what is wrong.
===========================================================
EOF
fi

